<?xml version="1.0" standalone="yes" ?>
<?xml-stylesheet href="x2script.xsl" type="text/xsl" ?>
<script>
<name>plugin.Xai.lib.db.basic</name>
<version>2</version>
<engineversion>25</engineversion>
<description>database append and fetch function</description>
<arguments>
<argument index="1" name="row.name" type="Value" desc="Row label" />
<argument index="2" name="row.data" type="Value" desc="Row data" />
<argument index="3" name="table.name" type="Var/String" desc="Table name" />
</arguments>
<sourcetext>
<line linenr="001" indent=""><comment><text>*&#160;</text><var>Created&#160;by&#160;Xai&#160;Corporation,&#160;764</var></comment></line>
<line linenr="002" indent=""><comment><text>*&#160;</text><var></var></comment></line>
<line linenr="003" indent=""><comment><text>*&#160;</text><var>Free&#160;for&#160;use&#160;in&#160;third&#160;party&#160;scripts,&#160;but</var></comment></line>
<line linenr="004" indent=""><comment><text>*&#160;</text><var>&#160;please&#160;mention&#160;Xai&#160;Corporation&#160;in&#160;your&#160;documentation</var></comment></line>
<line linenr="005" indent=""><comment><text>*&#160;</text><var></var></comment></line>
<line linenr="006" indent=""><comment><text>*&#160;</text><var>Uses&#160;arrays&#160;within&#160;arrays&#160;to&#160;create&#160;a&#160;database&#160;table&#160;stored&#160;in&#160;a&#160;local&#160;variable</var></comment></line>
<line linenr="007" indent=""><comment><text>*&#160;</text><var></var></comment></line>
<line linenr="008" indent=""></line>
<line linenr="009" indent=""><comment><text>*&#160;</text><var>fetch&#160;local&#160;array</var></comment></line>
<line linenr="010" indent=""><var>$table&#160;=&#160;</var><var>[THIS]&#160;-&gt;</var><text>&#160;get&#160;local&#160;variable:&#160;name=</text><var>$table.name</var></line>
<line linenr="011" indent=""><var>skip&#160;if&#160;</var><var>$table</var></line>
<line linenr="012" indent="&#160;"><var>$table&#160;=&#160;</var><text>&#160;array&#160;alloc:&#160;size=</text><var>0</var></line>
<line linenr="013" indent=""></line>
<line linenr="014" indent=""><var>$row.nums&#160;=&#160;</var><text>&#160;size&#160;of&#160;array&#160;</text><var>$table</var></line>
<line linenr="015" indent=""></line>
<line linenr="016" indent=""><comment><text>*&#160;</text><var>scan&#160;for&#160;existing&#160;entry</var></comment></line>
<line linenr="017" indent=""><var>while&#160;</var><var>$row.nums</var></line>
<line linenr="018" interruptable="@" indent="&#160;"><var>=&#160;</var><text>wait&#160;randomly&#160;from&#160;</text><var>1</var><text>&#160;to&#160;</text><var>20</var><text>&#160;ms</text></line>
<line linenr="019" indent="&#160;"><text>dec&#160;</text><var>$row.nums&#160;=&#160;</var></line>
<line linenr="020" indent="&#160;"><var>$row&#160;=&#160;</var><var>$table</var><text>[</text><var>$row.nums</var><text>]</text></line>
<line linenr="021" indent="&#160;"><var>$row.lable&#160;=&#160;</var><var>$row</var><text>[</text><var>0</var><text>]</text></line>
<line linenr="022" indent="&#160;"><var>skip&#160;if&#160;not&#160;</var><var>$row.lable</var><text>&#160;</text><var>==</var><text>&#160;</text><var>$row.name</var></line>
<line linenr="023" indent="&#160;&#160;"><text>break</text></line>
<line linenr="024" indent=""><text>end</text></line>
<line linenr="025" indent=""></line>
<line linenr="026" indent=""></line>
<line linenr="027" indent=""><comment><text>*&#160;</text><var>append&#160;or&#160;alter&#160;data</var></comment></line>
<line linenr="028" indent=""><var>if&#160;</var><var>$row.data</var></line>
<line linenr="029" indent="&#160;"><var>if&#160;not&#160;</var><var>$row.nums</var></line>
<line linenr="030" indent="&#160;&#160;"><text>append&#160;</text><var>$row.data</var><text>&#160;to&#160;array&#160;</text><var>$table</var></line>
<line linenr="031" indent="&#160;&#160;"></line>
<line linenr="032" indent="&#160;"><text>else</text></line>
<line linenr="033" indent="&#160;&#160;"><var>$column.num&#160;=&#160;</var><text>&#160;size&#160;of&#160;array&#160;</text><var>$row</var></line>
<line linenr="034" indent="&#160;&#160;"><var>while&#160;</var><var>$column.num</var></line>
<line linenr="035" indent="&#160;&#160;&#160;"><text>dec&#160;</text><var>$column.num&#160;=&#160;</var></line>
<line linenr="036" indent="&#160;&#160;&#160;"><var>$data&#160;=&#160;</var><var>$row.data</var><text>[</text><var>$column.num</var><text>]</text></line>
<line linenr="037" indent="&#160;&#160;&#160;"><var>$row</var><text>[</text><var>$column.num</var><text>]&#160;=&#160;</text><var>$data</var></line>
<line linenr="038" indent="&#160;&#160;"><text>end</text></line>
<line linenr="039" indent="&#160;&#160;"></line>
<line linenr="040" indent="&#160;"><text>end</text></line>
<line linenr="041" indent="&#160;"><var>[THIS]&#160;-&gt;</var><text>&#160;set&#160;local&#160;variable:&#160;name=</text><var>$table.name</var><text>&#160;value=</text><var>$table</var></line>
<line linenr="042" indent="&#160;"></line>
<line linenr="043" indent=""><comment><text>*&#160;</text><var>or&#160;return&#160;row</var></comment></line>
<line linenr="044" indent=""><text>else</text></line>
<line linenr="045" indent="&#160;"><var>skip&#160;if&#160;not&#160;</var><var>$row.lable</var><text>&#160;</text><var>==</var><text>&#160;</text><var>$row.name</var></line>
<line linenr="046" indent="&#160;&#160;"><var>$row.data&#160;=&#160;</var><var>$row</var></line>
<line linenr="047" indent=""><text>end</text></line>
<line linenr="048" indent=""></line>
<line linenr="049" indent=""><text>return&#160;</text><var>$row.data</var></line>
</sourcetext>
<codearray>
<sval type="array" size="10"><sval type="string" val="plugin.Xai.lib.db.basic" /><sval type="int" val="25" /><sval type="string" val="database append and fetch function" /><sval type="int" val="2" /><sval type="int" val="0" /><sval type="array" size="9"><sval type="string" val="row.name" /><sval type="string" val="row.data" /><sval type="string" val="table.name" /><sval type="string" val="table" /><sval type="string" val="row.nums" /><sval type="string" val="row" /><sval type="string" val="row.lable" /><sval type="string" val="column.num" /><sval type="string" val="data" /></sval><sval type="array" size="27"><sval type="array" size="6"><sval type="int" val="156" /><sval type="int" val="131075" /><sval type="int" val="65536" /><sval type="int" val="131074" /><sval type="int" val="2" /><sval type="int" val="3" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-536870137" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="3" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="4"><sval type="int" val="128" /><sval type="int" val="3" /><sval type="int" val="4" /><sval type="int" val="0" /></sval><sval type="array" size="4"><sval type="int" val="131" /><sval type="int" val="4" /><sval type="int" val="131074" /><sval type="int" val="3" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-1610609655" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="4" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="6"><sval type="int" val="107" /><sval type="int" val="-2147483647" /><sval type="int" val="4" /><sval type="int" val="1" /><sval type="int" val="4" /><sval type="int" val="20" /></sval><sval type="array" size="2"><sval type="int" val="143" /><sval type="int" val="4" /></sval><sval type="array" size="6"><sval type="int" val="129" /><sval type="int" val="5" /><sval type="int" val="131074" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="4" /></sval><sval type="array" size="6"><sval type="int" val="129" /><sval type="int" val="6" /><sval type="int" val="131074" /><sval type="int" val="5" /><sval type="int" val="4" /><sval type="int" val="0" /></sval><sval type="array" size="13"><sval type="int" val="104" /><sval type="int" val="-1610609912" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="6" /><sval type="int" val="131074" /><sval type="int" val="0" /><sval type="int" val="15" /><sval type="int" val="0" /><sval type="int" val="3" /><sval type="int" val="-1" /><sval type="int" val="0" /><sval type="int" val="-2" /></sval><sval type="array" size="2"><sval type="int" val="112" /><sval type="int" val="12" /></sval><sval type="array" size="2"><sval type="int" val="112" /><sval type="int" val="4" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-1610606589" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="1" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-536866812" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="4" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="5"><sval type="int" val="135" /><sval type="int" val="131074" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="1" /></sval><sval type="array" size="2"><sval type="int" val="112" /><sval type="int" val="22" /></sval><sval type="array" size="4"><sval type="int" val="131" /><sval type="int" val="7" /><sval type="int" val="131074" /><sval type="int" val="5" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="-1610607095" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="7" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="2"><sval type="int" val="143" /><sval type="int" val="7" /></sval><sval type="array" size="6"><sval type="int" val="129" /><sval type="int" val="8" /><sval type="int" val="131074" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="7" /></sval><sval type="array" size="7"><sval type="int" val="130" /><sval type="int" val="131074" /><sval type="int" val="5" /><sval type="int" val="131074" /><sval type="int" val="7" /><sval type="int" val="131074" /><sval type="int" val="8" /></sval><sval type="array" size="2"><sval type="int" val="112" /><sval type="int" val="17" /></sval><sval type="array" size="7"><sval type="int" val="155" /><sval type="int" val="131075" /><sval type="int" val="65536" /><sval type="int" val="131074" /><sval type="int" val="2" /><sval type="int" val="131074" /><sval type="int" val="3" /></sval><sval type="array" size="2"><sval type="int" val="112" /><sval type="int" val="26" /></sval><sval type="array" size="13"><sval type="int" val="104" /><sval type="int" val="-1610606072" /><sval type="int" val="3" /><sval type="int" val="131074" /><sval type="int" val="6" /><sval type="int" val="131074" /><sval type="int" val="0" /><sval type="int" val="15" /><sval type="int" val="0" /><sval type="int" val="3" /><sval type="int" val="-1" /><sval type="int" val="0" /><sval type="int" val="-2" /></sval><sval type="array" size="7"><sval type="int" val="104" /><sval type="int" val="1" /><sval type="int" val="1" /><sval type="int" val="131074" /><sval type="int" val="5" /><sval type="int" val="1" /><sval type="int" val="-1" /></sval><sval type="array" size="3"><sval type="int" val="103" /><sval type="int" val="131074" /><sval type="int" val="1" /></sval></sval><sval type="array" size="3"><sval type="array" size="2"><sval type="int" val="9" /><sval type="string" val="Row label" /></sval><sval type="array" size="2"><sval type="int" val="9" /><sval type="string" val="Row data" /></sval><sval type="array" size="2"><sval type="int" val="11" /><sval type="string" val="Table name" /></sval></sval><sval type="array" size="27"><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="Created by Xai Corporation, 764" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="Free for use in third party scripts, but" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val=" please mention Xai Corporation in your documentation" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="Uses arrays within arrays to create a database table stored in a local variable" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="" /></sval><sval type="array" size="2"><sval type="int" val="0" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="0" /><sval type="int" val="1" /><sval type="string" val="fetch local array" /></sval><sval type="array" size="2"><sval type="int" val="3" /><sval type="int" val="2" /></sval><sval type="array" size="2"><sval type="int" val="4" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="4" /><sval type="int" val="1" /><sval type="string" val="scan for existing entry" /></sval><sval type="array" size="2"><sval type="int" val="11" /><sval type="int" val="7" /></sval><sval type="array" size="2"><sval type="int" val="12" /><sval type="int" val="4" /></sval><sval type="array" size="2"><sval type="int" val="12" /><sval type="int" val="2" /></sval><sval type="array" size="2"><sval type="int" val="12" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="12" /><sval type="int" val="1" /><sval type="string" val="append or alter data" /></sval><sval type="array" size="2"><sval type="int" val="15" /><sval type="int" val="2" /></sval><sval type="array" size="2"><sval type="int" val="16" /><sval type="int" val="5" /></sval><sval type="array" size="2"><sval type="int" val="22" /><sval type="int" val="4" /></sval><sval type="array" size="2"><sval type="int" val="22" /><sval type="int" val="2" /></sval><sval type="array" size="2"><sval type="int" val="22" /><sval type="int" val="4" /></sval><sval type="array" size="2"><sval type="int" val="23" /><sval type="int" val="2" /></sval><sval type="array" size="3"><sval type="int" val="23" /><sval type="int" val="1" /><sval type="string" val="or return row" /></sval><sval type="array" size="2"><sval type="int" val="24" /><sval type="int" val="5" /></sval><sval type="array" size="2"><sval type="int" val="26" /><sval type="int" val="4" /></sval><sval type="array" size="2"><sval type="int" val="26" /><sval type="int" val="2" /></sval></sval><sval type="int" val="0" /></sval>
</codearray>
</script>
